<?php
/*! 
 * This is small PHP script which converts the JSON-formatted track data of the
 * VendeeGlobe 2020 online tracker to OSM format.
 *
 * \file boats.php
 * \author Bernhard R. Fischer, 4096R/8E24F29D <bf@abenteuerland.at>
 * \date 2021/01/05
 * \license Buy me a beer when me meet the next time :)
 *
 */


$IDOFF = 180362000000;

$boats = array(
   array("id" => "79", "name" => "APIVIA", "sail" => "FRA 79", "nbhulls" => "4", "hullcolors" => "E0FB41|FFFFFF|363635", "trackcolor" => "E0FB41", "coef" => "1000", "comment" => ""),
   array("id" => "4", "name" => "ARKEA PAPREC", "sail" => "FRA 4", "nbhulls" => "4", "hullcolors" => "6A73C2|FFFFFF|E00E1F", "trackcolor" => "6A73C2", "coef" => "1000", "comment" => ""),
   array("id" => "30", "name" => "Banque Populaire X", "sail" => "FRA 30", "nbhulls" => "1", "hullcolors" => "489AD1|FFFFFF|215CA3", "trackcolor" => "489AD1", "coef" => "1000", "comment" => ""),
   array("id" => "18", "name" => "Bureau Vallée 2", "sail" => "FRA 18", "nbhulls" => "4", "hullcolors" => "F9DE51|D9FBE1|0F9531", "trackcolor" => "F9DE51", "coef" => "1000", "comment" => ""),
   array("id" => "37", "name" => "Campagne de France", "sail" => "FRA 50", "nbhulls" => "1", "hullcolors" => "9ECF3F|FFFFFF|214635", "trackcolor" => "9ECF3F", "coef" => "1000", "comment" => ""),
   array("id" => "8", "name" => "Charal", "sail" => "FRA 8", "nbhulls" => "4", "hullcolors" => "000000|C4C4C6|CC392A", "trackcolor" => "FFFFFF", "coef" => "1000", "comment" => ""),
   array("id" => "83", "name" => "Compagnie du lit - Jiliti", "sail" => "FRA 83", "nbhulls" => "1", "hullcolors" => "203163|FFFFFF|FAD714", "trackcolor" => "859AD8", "coef" => "1000", "comment" => ""),
   array("id" => "1", "name" => "CORUM L'Épargne", "sail" => "FRA 6", "nbhulls" => "4", "hullcolors" => "008B96|FFFFFF|C0933B", "trackcolor" => "04ECFF", "coef" => "1000", "comment" => ""),
   array("id" => "1101", "name" => "DMG MORI Global One", "sail" => "JPN 11", "nbhulls" => "4", "hullcolors" => "362C2B|FFFFFF|C9C9C9", "trackcolor" => "C9C9C9", "coef" => "1000", "comment" => ""),
   array("id" => "1000", "name" => "Groupe APICIL", "sail" => "FRA 1000", "nbhulls" => "1", "hullcolors" => "CD3A4A|FFFFFF|6C6D70", "trackcolor" => "CD3A4A", "coef" => "1000", "comment" => ""),
   array("id" => "71", "name" => "Groupe Sétin", "sail" => "FRA 71", "nbhulls" => "1", "hullcolors" => "4A89C5|31599A|F1CB29", "trackcolor" => "4A89C5", "coef" => "1000", "comment" => ""),
   array("id" => "99", "name" => "HUGO BOSS", "sail" => "GBR 99", "nbhulls" => "4", "hullcolors" => "000000|FF1659|000000", "trackcolor" => "FFFFFF", "coef" => "1000", "comment" => ""),
   array("id" => "109", "name" => "Initiatives - Coeur", "sail" => "FRA 109", "nbhulls" => "4", "hullcolors" => "E90017|FFFFFF|FF7D87", "trackcolor" => "E90017", "coef" => "1000", "comment" => ""),
   array("id" => "2", "name" => "L'Occitane en Provence", "sail" => "FRA 02", "nbhulls" => "4", "hullcolors" => "0C1212|0C1212|FEC833", "trackcolor" => "FEC833", "coef" => "1000", "comment" => ""),
   array("id" => "7", "name" => "La Fabrique", "sail" => "SUI 7", "nbhulls" => "4", "hullcolors" => "CD4722|963823|F0DAA8", "trackcolor" => "CD4722", "coef" => "1000", "comment" => ""),
   array("id" => "14", "name" => "La Mie Câline - Artisans Artipôle", "sail" => "FRA 14", "nbhulls" => "4", "hullcolors" => "F8D500|004485|FFFFFF", "trackcolor" => "F8D500", "coef" => "1000", "comment" => ""),
   array("id" => "59", "name" => "LinkedOut", "sail" => "FRA 59", "nbhulls" => "4", "hullcolors" => "43A5D6|1A5A7D|FFFFFF", "trackcolor" => "43A5D6", "coef" => "1000", "comment" => ""),
   array("id" => "27", "name" => "MACSF", "sail" => "FRA 27", "nbhulls" => "4", "hullcolors" => "B6B8C8|FFFFFF|DF3635", "trackcolor" => "FFFFFF", "coef" => "1000", "comment" => ""),
   array("id" => "17", "name" => "Maître Coq IV", "sail" => "FRA 17", "nbhulls" => "4", "hullcolors" => "EE2E24|000000|84BC4E", "trackcolor" => "EE2E24", "coef" => "1000", "comment" => ""),
   array("id" => "777", "name" => "Medallia", "sail" => "GBR 777", "nbhulls" => "1", "hullcolors" => "C1C0C1|F3F3F3|6D80FC", "trackcolor" => "6D80FC", "coef" => "1000", "comment" => ""),
   array("id" => "69", "name" => "Merci", "sail" => "FRA 69", "nbhulls" => "1", "hullcolors" => "FFFFFF|F16625|214293", "trackcolor" => "FFFFFF", "coef" => "1000", "comment" => ""),
   array("id" => "56", "name" => "Newrest - Art et Fenetres", "sail" => "FRA 56", "nbhulls" => "4", "hullcolors" => "212121|565656|88B759", "trackcolor" => "88B759", "coef" => "1000", "comment" => ""),
   array("id" => "9", "name" => "OMIA - Water Family", "sail" => "FRA 09", "nbhulls" => "1", "hullcolors" => "133558|12A9C2|EE4F22", "trackcolor" => "EE4F22", "coef" => "1000", "comment" => ""),
   array("id" => "33", "name" => "One Planet One Ocean", "sail" => "ESP 33", "nbhulls" => "1", "hullcolors" => "FFFFFF|0497C7|004A8E", "trackcolor" => "319AF9", "coef" => "1000", "comment" => ""),
   array("id" => "85", "name" => "PRB", "sail" => "FRA 85", "nbhulls" => "4", "hullcolors" => "E18230|FFFFFF|000000", "trackcolor" => "E18230", "coef" => "1000", "comment" => ""),
   array("id" => "34", "name" => "Prysmian Group", "sail" => "ITA 34", "nbhulls" => "4", "hullcolors" => "F2F2F1|000000|D1D1CD", "trackcolor" => "F2F2F1", "coef" => "1000", "comment" => ""),
   array("id" => "49", "name" => "Pure - Best Western Hotels and Resorts", "sail" => "FRA 49", "nbhulls" => "1", "hullcolors" => "EC6F35|14376C|C5D12F", "trackcolor" => "EC6F35", "coef" => "1000", "comment" => ""),
   array("id" => "10", "name" => "Seaexplorer - Yacht Club De Monaco", "sail" => "MON 10", "nbhulls" => "4", "hullcolors" => "A9A5A4|CC3030|373737", "trackcolor" => "F2F2F2", "coef" => "1000", "comment" => ""),
   array("id" => "222", "name" => "Stark", "sail" => "FIN 222", "nbhulls" => "1", "hullcolors" => "E4E4E4|244070|E18D32", "trackcolor" => "E18D32", "coef" => "1000", "comment" => ""),
   array("id" => "92", "name" => "Time For Oceans", "sail" => "FRA 92", "nbhulls" => "4", "hullcolors" => "1EB8D7|0083AD|FFFFFF", "trackcolor" => "1EB8D7", "coef" => "1000", "comment" => ""),
   array("id" => "72", "name" => "TSE - 4myplanet", "sail" => "FRA 72", "nbhulls" => "1", "hullcolors" => "D42788|FFFFFF|191919", "trackcolor" => "D42788", "coef" => "1000", "comment" => ""),
   array("id" => "53", "name" => "V And B Mayenne", "sail" => "FRA 53", "nbhulls" => "1", "hullcolors" => "5AAA4F|000000|EFCB89", "trackcolor" => "5AAA4F", "coef" => "1000", "comment" => ""),
   array("id" => "1001", "name" => "Yes we Cam !", "sail" => "FRA 01", "nbhulls" => "1", "hullcolors" => "FFFFFF|4E4F51|FFFFFF", "trackcolor" => "FFFFFF", "coef" => "1000", "comment" => ""),
);

//$rules = TRUE;
if (isset($rules))
{
   foreach ($boats as $boat)
   {
      $id = $boat["id"];
      $col = $boat["trackcolor"];
      print "<way>\n";
      print "<tag k=\"id\" v=\"$id\"/>\n<tag k=\"track\" v=\"VG2020\"/>\n";
      print "<tag k=\"_action_\" v=\"draw:bcolor=#$col\"/>\n";
      print "</way>\n";
   }
   exit(0);
}


$tracks = json_decode(file_get_contents("tracks.json"), TRUE);

$rev = array();

for ($i = 0; $i < count($boats); $i++)
   $rev[$boats[$i]["id"]] = $i;

print "<?xml version=\"1.0\" encoding=\"UTF-8\"?>\n<osm version=\"0.6\" generator=\"bfvgtrack\">\n";
//print_r($tracks);
foreach ($tracks["tracks"] as $track)
{
   $id = $track["id"];

   if (!isset($rev[$id]))
   {
      print "<!-- unknown id $id -->\n";
      continue;
   }

   $i = 0;
   $lat = 0.0;
   $lon = 0.0;
   $tim = 0;
   $n = count($track["loc"]);
   foreach ($track["loc"] as $point)
   {
      $tim += $point[0];
      $lat += $point[1] / 100000.0;
      $lon += $point[2] / 100000.0;

      $nid = $id * 5000 + $i + $IDOFF;
      $ts = gmdate("Y-m-d\TH:i:s\Z", $tim);
      $i++;

      if ($i < $n)
         print "<node id=\"{$nid}\" timestamp=\"{$ts}\" lat=\"{$lat}\" lon=\"{$lon}\" version=\"1\"/>\n";
      else
      {
         print "<node id=\"{$nid}\" timestamp=\"{$ts}\" lat=\"{$lat}\" lon=\"{$lon}\" version=\"1\">\n";
         $boat = $boats[$rev[$id]];
         print "<tag k=\"name\" v=\"{$boat["name"]}\"/>\n<tag k=\"trackcolor\" v=\"#{$boat["trackcolor"]}\"/>\n";
         print "<tag k=\"bgcolor\" v=\"#30{$boat["trackcolor"]}\"/>\n";
         print "<tag k=\"id\" v=\"$id\"/>\n<tag k=\"track\" v=\"VG2020\"/>\n";
         print "</node>\n";
      }
   }
}


//print_r($rev);
foreach ($tracks["tracks"] as $track)
{
   $id = $track["id"];

   if (!isset($rev[$id]))
   {
      print "<!-- unknown id $id -->\n";
      continue;
   }

   $boat = $boats[$rev[$id]];
   $wid = $id + $IDOFF;

   print "<way id=\"{$wid}\" version=\"1\">\n<tag k=\"name\" v=\"{$boat["name"]}\"/>\n<tag k=\"trackcolor\" v=\"#{$boat["trackcolor"]}\"/>\n";
   print "<tag k=\"id\" v=\"$id\"/>\n<tag k=\"track\" v=\"VG2020\"/>\n";

   $i = 0;
   foreach ($track["loc"] as $point)
   {
      $nid = $id * 5000 + $i + $IDOFF;
      $i++;
      print "<nd ref=\"$nid\"/>\n";
   }

   print "</way>\n";
}

print "</osm>\n";

?>
